#ifndef OBJECT_H_
#define OBJECT_H_

#include <vector>
#include "vec.h"
#include "matrix.h"

class Object {
private:
	Vector3 pos;
	Vector3 rot_axis;
	float rot_angle;
	Vector3 scale;

	float color[4];

	Matrix4x4 matrix;

public:
	Object();
	~Object();

	void set_color(float r, float g, float b);

	void set_position(float x, float y, float z);
	void set_rotation(float angle, float x, float y, float z);
	void set_scaling(float sx, float sy, float sz);

	void update();

	void draw() const;
};


#endif	// OBJECT_H_
